<?php

namespace app\controller;

use app\model\UserModel;
use app\validate\UserValidate;
use think\facade\Db;
use think\facade\Request;

class User extends Base
{
    public function save()
    {
        $param['account'] = Request::param('account/s', '', 'trim');
        $param['password'] = Request::param('password/s', '');
        $param['name'] = Request::param('name/s', '', 'trim');
        validate(UserValidate::class)->scene('save')->check($param);
        UserModel::create([
            'account' => $param['account'],
            'password' => password_hash($param['password'], PASSWORD_DEFAULT),
            'name' => $param['name'],
        ]);
        return success();
    }

    public function delete($id)
    {
        UserModel::find($id)->delete();
        return success();
    }

    public function update($id)
    {
        $param['name'] = Request::param('name/s', '', 'trim');
        UserModel::where('user_id', $id)->save([
            'name' => $param['name']
        ]);
        return success();
    }

    public function read($id)
    {
        $user = UserModel::where('user_id', $id)->find();
        return success($user);
    }

    public function index()
    {
        $list = Db::name('user')->paginate();
        return success($list);
    }
}