<?php

namespace app\service;

use app\model\AuthLogModel;

class TokenService
{
    public static function create($user)
    {
        $token = self::generateCode();
        $resource_token = self::generateCode();
        AuthLogModel::create([
            'user_id' => $user['user_id'],
            'token' => $token,
            'resource_token' => $resource_token,
            'status' => 1
        ]);
        return [
            'token' => $token . '|' . $user['user_id'],
            'resource_token' => $resource_token . '|' . $user['user_id'],
        ];
    }

    /**
     * 生成 Token
     * @param int $code_length Token 长度
     * @return string          返回优惠码数组
     */
    private static function generateCode($code_length = 32): string
    {
        $characters = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
        $code = '';
        for ($i = 0; $i < $code_length; $i++) {
            $code .= $characters[mt_rand(0, strlen($characters) - 1)];
        }

        return $code;
    }
}