<?php

namespace app\validate;

use app\model\UserModel;
use think\Validate;

class UserValidate extends Validate
{
    protected $rule = [
        'account' => ['require', 'checkRepeat'],
        'password' => ['require'],
        'name' => ['requireSpecialName'],
    ];
    protected $message = [
        'account.require' => '用户名不能为空',
        'account.checkRepeat' => '用户名不能重复',
        'password' => '密码不能重复',
        'name' => '系统保留的用户名',
    ];

    protected $scene = [
        'save' => ['account', 'password']
    ];

    // 没有 require 开头的，如果参数为空，就不会验证
    protected function checkRepeat($vale, $rule, $data = []): bool
    {
        $user = UserModel::where('account', $vale)->find();
        // mysql binary
        // $user = UserModel::where('account', 'exp', "='$vale' COLLATE utf8mb4_bin")->find();
        // $user = UserModel::where('account', 'exp', "='$vale' COLLATE utf8mb4_general_ci")->find();
        return empty($user);
    }

    // require 开头的，即使参数为空也会验证
    protected function requireSpecialName($vale, $rule, $data = []): bool
    {
        return !in_array($vale, ['GuoDapeng', 'GDP']);
    }
}